# Originele uitvoering: Robbin, netheid: Taha
from ncclient import manager  # python3 -m pip install ncclient
import xml.dom.minidom

routers = {'ISP':'10.5.5.2', 'EdgeRouter':'10.5.5.3', 'R3':'10.5.5.4'}

username = input("New username: ")
password = input("Password: ")
level = input("Privilege level: ")



for router in routers:
    print(f"{'*'*6} working on: {router} {'*'*6}")
    m = manager.connect(
        host=routers[router],
        port=830,
        username="cisco",
        password="cisco",
        hostkey_verify=False
        )

    netconf_user = f"""
    <config>
      <native xmlns="http://cisco.com/ns/yang/Cisco-IOS-XE-native">
         <username>
                <name>{username}</name>
                <privilege>{level}</privilege>
                <password>
                        <encryption>0</encryption>
                <password>{password}</password>
                </password>
        </username>
      </native>
    </config>
    """
    try:
        netconf_reply = m.edit_config(target="running", config=netconf_user)
        print(xml.dom.minidom.parseString(netconf_reply.xml).toprettyxml())
    except:
        print(f'Error working for {router}')
